#ifndef __EXT_API_DEFINES_INCLUDED__
#define __EXT_API_DEFINES_INCLUDED__

#pragma once

#include <afx.h>

// variable handles

typedef void* ZVAR;
typedef void* ZMAP;
typedef void* ZLIST;
typedef void* ZFUNC;
typedef void* ZFORMAT;

// some selected variable type defines

#define VarID_INVALID		0
#define VarID_void			1
#define VarID_var			2 // variant type, data is another ZVAR
#define VarID_bool			3
#define VarID_char			4
#define VarID_byte			5
#define VarID_short			6
#define VarID_int			7
#define VarID_int64			8
#define VarID_float			9
#define VarID_double		10
#define VarID_string		11
#define VarID_buffer		15
#define VarID_LPVOID		20
#define VarID_varlist		31
#define VarID_map			60
#define VarID_format		100
#define VarID_ComboSelector	302
#define VarID_ZeoFunc		510
#define VarID_ProgBox		600

// map type defines

#define MAP_Empty				0
#define MAP_BYTE				1
#define MAP_WORD				2
#define MAP_24bit				3
#define MAP_DWORD				4

#define MAP_DesignMap			10	// DM
#define MAP_Heightfield			20	// HF
#define MAP_TerrainNormals		30	// TN
#define MAP_AttributesMap		40	// AM
#define MAP_WaterMap			50	// WM
#define MAP_AuxWaterMap			52	// AuxWM

// map flags (for use with map_GetFlag/SetFlag)

#define MAPFLAG_READY		1
#define MAPFLAG_SAVED		2
#define MAPFLAG_MOSAIC		3
#define MAPFLAG_INVALID		4
#define MAPFLAG_MODIFIED	5
#define MAPFLAG_SEAMFIX		6

// pixel type structs

typedef struct {
	short int  Alt;		// exact altitude (in m) (-32k -> 32k)
	BYTE Peak;			// cone strength
	BYTE Frac;			// fractal strength
	BYTE Cliffs;		// cliff / plateau strength
	BYTE Erosion;
	BYTE Lakes;			// lake number / size
	BYTE Climate;
	BYTE SpecType;		// Mountain, Plateau, Volcano
	BYTE SpecParam;
} DesignMapPixel;

typedef struct {
	BYTE ClimateID;		// index of climate in group list
	BYTE LandTypeID;	// index of land type in climate
} AttributesPixel;

typedef struct {
	USHORT WaterID;	// identifies the body of water holding this pixel
	BYTE Type;
	float WaterLevel;
} WaterMapPixel;

typedef struct {
	BYTE Type;
	BYTE DoneFlag;
	float WaterLevel;
} AuxWaterMapPixel;

typedef struct { signed char x, y, z; } vector3sc;
typedef vector3sc TerrainNormalPixel;

typedef struct {
	BYTE r;
	BYTE g;
	BYTE b;
} ColourPixel;

#endif