#pragma once
#include "zvar.h"

class CzMap :
	public CzVar
{
public:
	CzMap(void);
	~CzMap(void);

	bool Create(LPCSTR lpVarName = NULL);

	bool	Init(long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
	bool	Free();
	long	GetMapType();
	long	GetPixelSize();
	bool	GetWrapFlag();
	bool	SetWrapFlag(bool WrapFlag);
	bool	GetBusyFlag();
	bool	SetBusyFlag(bool BusyFlag);
	long	nx(); // get height
	long	ny(); // get height
	bool	GetPixel(long x, long y, void* pValue);
	bool	SetPixel(long x, long y, void* pValue);
	bool	GetMinMaxAlt(float& minval, float& maxval);
	bool	SetMinMaxAlt(float& minval, float& maxval);
	float	GetHorizScale();
	bool	GetMosaicFlag();
	long	GetMosaicTileSize();
	long	GetMosaicTilesX();
	long	GetMosaicTilesY();
	bool	GetFlag(long FlagID);
	bool	SetFlag(long FlagID, bool FlagValue);
	ZLIST	GetSettingsList();
	bool	SaveFile(LPCSTR lpFileName, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
	bool	LoadFile(LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, bool SetFlags, bool ShowProgress);
	bool	GetNameInProject(ZVAR hStr);
	bool	InitMosaic(long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag, LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
	bool	LoadMosaic(LPCSTR lpMosaicFileName);
	bool	SaveMosaic();
	ZFORMAT GetFormat();
	bool	SetFormat(ZFORMAT hFormat);
	LPCSTR	GetFilename();
	bool	CombineMosaic();
	bool	SplitToMosaic(LPCSTR lpMosaicFileName, long TileSize, ZFORMAT hFormat, LPCSTR lpProjMapName);
	bool	SaveMosaicAs(LPCSTR lpFileName);
	bool	ExportMap(LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny);
	bool	ExportMosaic(LPCSTR lpFileName, ZFORMAT hFormat, long nx, long ny, long TileSize, LPCSTR lpProjMapName);
};
